#!/usr/bin/env python

import re, urllib
import web

def language(phrase): 
   languages = {
      'english': 'en', 
      'french': 'fr', 
      'rumantsch': 'fr', 
      'bosnian': 'fr', 
      'spanish': 'es', 
      'romanian': 'es', 
      'portuguese': 'pt', 
      'german': 'de', 
      'italian': 'it', 
      'korean': 'ko', 
      'japanese-shift_jis': 'ja', 
      'unknown': 'ja'
   }
 
   query = urllib.quote(phrase)
   bytes = web.get('http://www.eidetica.com/services/guesser?string=' + query)
   for line in bytes.splitlines(): 
      if '"#7FC0A0">' in line: 
         language = line[line.find('"#7FC0A0">') + 10: line.find('</TD>')]
         return languages[language.strip(' \t').lower()]
   return None

def language(self, phrase): 
   languages = {
      'english': 'en', 
      'french': 'fr', 
      'spanish': 'es', 
      'portuguese': 'pt', 
      'german': 'de', 
      'italian': 'it', 
      'korean': 'ko', 
      'japanese': 'ja', 
      'chinese': 'zh', 
      'dutch': 'nl', 
      'greek': 'el', 
      'russian': 'ru'
   }

   uri = 'http://www.xrce.xerox.com/cgi-bin/mltt/LanguageGuesser'
   form = {'Text': phrase}
   bytes = web.post(uri, form)
   for line in bytes.splitlines(): 
      if '<listing><font size=+1>' in line: 
         i = line.find('<listing><font size=+1>')
         lang = line[i+len('<listing><font size=+1>'):].strip()
         lang = lang.lower()
         if '_' in lang: 
            j = lang.find('_')
            lang = lang[:j]
         try: return languages[lang]
         except KeyError: 
            return lang
   return 'unknown'

r_translation = re.compile(r'<div style=padding:10px;>([^<]+)</div>')

def translate(phrase, lang, target='en'): 
   babelfish = 'http://world.altavista.com/tr'
   form = {
      'doit': 'done', 
      'intl': '1', 
      'tt': 'urltext', 
      'trtext': phrase, 
      'lp': lang + '_' + target
   }

   bytes = web.post(babelfish, form)
   m = r_translation.search(bytes)
   if m: 
      translation = m.group(1)
      translation = translation.replace('\r', ' ')
      translation = translation.replace('\n', ' ')
      while '  ' in translation:
         translation = translation.replace('  ', ' ')
      return translation
   return None

def f_translate(self, origin, match, args): 
   """phenny: "<phrase>"? - Translate <phrase>"""
   phrase = match.group(2)

   # if len(phrase) < 15: 
   #    self.msg(origin.sender, origin.nick + ': Phrase must be >= 15 chars.')
   #    return # Unable to guess the language
   try: length = len(phrase.decode('utf-8'))
   except: length = len(phrase)

   if (length > 350) and (origin.nick != 'sbp'): 
      self.msg(origin.sender, origin.nick + ': Phrase must be <= 350 chars.')
      return # Too much input

   try: # thanks to nicomen! cf. http://utilitybase.com/paste/3544
      mlang = match.group(1)
      if mlang: 
         lang = mlang
      else: lang = language(self, phrase)
   except KeyError, e: 
      msg = "Hmm, got %s..." % str(e).split().pop()
      self.msg(origin.sender, origin.nick + ": " + msg)
      return

   if lang is None: 
      self.msg(origin.sender, origin.nick + ": Couldn't guess the language")
      return

   if lang != 'en': 
      translation = translate(phrase, lang)
      if translation is not None: 
         msg = '"%s" (%s)' % (translation, lang)
         self.msg(origin.sender, origin.nick + ': ' + msg)
      else: self.msg(origin.sender, origin.nick + ': Hmm, got "%s"...' % lang)
   else: 
      translation = translate(phrase, 'en', 'de')
      translation = translate(translation, 'de', 'en')
      translation = translate(translation, 'en', 'ja')
      translation = translate(translation, 'ja', 'en')
      if translation is not None: 
         msg = '"%s" (en -...-> en)' % translation
         self.msg(origin.sender, origin.nick + ': ' + msg)
      else: self.msg(origin.sender, origin.nick + ': Hmm! Got "en"...')

f_translate.rule = r'^$nick[,:] +(?:([a-z]{2}) +)?"(.+)"\? *$'
f_translate.thread = True

def f_mangle(self, origin, match, args): 
   """.mangle <phrase> - Mangle <phrase>"""
   phrase = match.group(1)

   import time
   translation = translate(phrase, 'en', 'fr')
   time.sleep(0.25)
   translation = translate(translation, 'fr', 'en')
   time.sleep(0.25)
   translation = translate(translation, 'en', 'de')
   time.sleep(0.25)
   translation = translate(translation, 'de', 'en')
   time.sleep(0.25)
   translation = translate(translation, 'en', 'es')
   time.sleep(0.25)
   translation = translate(translation, 'es', 'en')
   time.sleep(0.25)
   translation = translate(translation, 'en', 'ko')
   time.sleep(0.25)
   translation = translate(translation, 'ko', 'en')
   time.sleep(0.25)
   translation = translate(translation, 'en', 'ja')
   time.sleep(0.25)
   translation = translate(translation, 'ja', 'en')
   time.sleep(0.25)
   translation = translate(translation, 'en', 'de')
   time.sleep(0.25)
   translation = translate(translation, 'de', 'en')
   time.sleep(0.25)
   translation = translate(translation, 'en', 'fr')
   time.sleep(0.25)
   translation = translate(translation, 'fr', 'en')
   if translation is not None: 
      msg = '"%s"' % translation
      self.msg(origin.sender, origin.nick + ': ' + msg[:350])
   else: self.msg(origin.sender, origin.nick + ': E_OMGLOL')

f_mangle.rule = (['mangle'], r'(.*)')
f_mangle.thread = True
